/*
 * iGeom by LInE
 * Free software to student private data
 *
 * http://www.matematica.br/igeom
 * http://www.usp.br/line
 *
 * Create and register new element MidPoint
 * It is used in ./app/core/application/menu.js
 *
 * ./app/component-registry/circumference-component.js
 * @version 2023/09/20: Added new parameter 'description,' to 'ComponentOptions'
 */

import { Component } from "../core/models/components/component";
import { ComponentOptions } from "../core/models/components/component-options";
import { CircumferenceDrawer } from "../components/circumference-component/drawers/circumference-drawer";

class CircumferenceComponent extends Component {

  //TODO: it is necessary internationalization!

  constructor () {
    const options = new ComponentOptions(
      "c83f6d14758c48f7b8fdb5ca69e46272",
      "Circumference",
      "Construct Circumference defined by Point (its center) and Point (defining its radius)",
      "circumference"
      );
    super(new CircumferenceDrawer(), options);
    }
  }

export const circumferenceComponent = new CircumferenceComponent();